function g = estimate_layer_labels_multi_layers_3frames_gd(this, layer_uv, prev_g, g2,g0,images0, layer_uv0)
% function g = estimate_layer_labels_multi_layers_3frames_gd(this, layer_uv, prev_g, g2)
% Multi-layers

% Energy function BCE(uv1) sigmoid(lambda4*g) + BCE(uv2) sigmoid(-g) + lambda2smoothness(g)

% prior is modulated by static image segmentation

% g0,images0, uv0 are for the previous (t-1) frame

%nGDiters = 30; % 50 little improvement

nGDiters = this.nGDiters; % 50 little improvement

nL = this.nLayers;

s2 = g2labels(g2, this.lambda4);
for i = 1:nL-1       
    warps2(:,:,i) = imwarp_grad_im(layer_uv{i}, s2(:,:,i));
    warpg2(:,:,i) = imwarp_grad_im(layer_uv{i}, g2(:,:,i));
end;
i = nL;
warps2(:,:,i) = imwarp_grad_im(layer_uv{i}, s2(:,:,i));
warps2(isnan(warps2)) = 0;
warpg2(isnan(warpg2)) = prev_g(isnan(warpg2));  % or zero?

% Compute BCE for each layer
for i = 1:nL       
   
    It = partial_deriv(this.images, layer_uv{i}, this.interpolation_method, this.deriv_filter);     
    %this.rho_data.param = this.sigmaNs(i);
    aIt2(:,:,i)          = reshape(evaluate(this.rho_data, It(:)), size(It)) - this.lambda5;
    
end;
aIt2 = aIt2.*warps2;


% Compute BCE for each layer at previous frame
for i = 1:nL       
   
    It = partial_deriv(images0, layer_uv0{i}, this.interpolation_method, this.deriv_filter);      
    %this.rho_data.param = this.sigmaNs(i);
    aIt20(:,:,i)          = reshape(evaluate(this.rho_data, It(:)), size(It))- this.lambda5;
    
end;
s0 = g2labels(g0, this.lambda4);
aIt20 = aIt20.*s0;

% compute the gradient for linear warping function
% for i = 1:nL       
%   [tmp warp_grad(:,:,i)] = imwarp_grad_im(layer_uv0{i}, layerLabels(:,:,i));              
% end;

% Call minimizer
% disp('seg');
% g = minimize(prev_g(:), @compute_g_con3_energy, nGDiters, warpg2, aIt2, ...
%     this.seg, this.g_filters, this.kappa, this.lambda2, this.lambda3, this.lambda4,...
%     aIt20, g0, layer_uv0);

g = minimize(prev_g(:), @compute_g_con3_energy, nGDiters, warpg2, aIt2, ...
    this.labImage, this.g_filters, this.kappa, this.lambda2, this.lambda3, this.lambda4,...
    aIt20, g0, layer_uv0);

% call minFunc : out of memory for 8nn prior
% 
% options.Display = 'none';
% g = minFunc(@compute_g_con3_energy, prev_g(:), options, ...
%             warpg2, aIt2, ...
%             this.seg, this.g_filters, this.kappa, this.lambda2, this.lambda3, this.lambda4,...
%             aIt20, g0, layer_uv0);

g = reshape(g, size(prev_g));
% % for debug
% for i = 1:nL-1 
%     tmp = g(:,:,i);
%     fprintf('%3.3e\t %3.3e\t', min(tmp(:)), max(tmp(:)));    
% end;
% fprintf('\n');

% function [e d] = compute_g_con_energy(g, warpg2, aIt2, this)
% [e d] = compute_g_con_energy(this, g, warpg2, aIt2)

function [e d] = compute_g_con3_energy(g, warpg2, aIt2, seg, F, kappa, lambda, lambda_g, lambda_s, aIt20, g0, layer_uv0)

% Data + smoothness prior + temporal consistency term

% for 3 frames involving g (second frame)

% nL = 4;
% sz = [10 10];
% g  = randn([sz nL-1]); g= g(:);
% warpg2 = randn([sz nL-1]);
% aIt2 = rand([sz nL])*10;
% seg = round(rand(sz)*25);
% F   = {[1 -1], [1; -1]};  
% lambda = 1;
% kappa = 0.5;
% lambda_g = 1;  lambda_s = 1;
% aIt20 = rand([sz nL])*10;
% g0  = randn([sz nL-1]);
% for i = 1:nL; layer_uv0{i} = randn([sz 2]); end;
% % for i = 1:nL
% % %%   [tmp warp_grad(:,:,i)] = imwarp_grad_im(layer_uv0{i}, g0(:,:, 1) );              
% % warp_grad{i} = imwarpmtx_for(layer_uv0{i});
% % end;

% d = checkgrad('compute_g_con3_energy', g, 1e-3, warpg2, aIt2, seg, F,  kappa, lambda, lambda_g, lambda_s, aIt20, g0, layer_uv0)


sz = size(aIt2);
nL = sz(3);
sz = sz(1:2);

g = reshape(g, [sz nL-1]);

% if nargin <4
%     seg = ones(size(g));        
% end;
% if nargin <5
%     kappa = 1;        
% end;
seg = double(seg);


% Compute energy

% data term
layerLabels = g2labels(g, lambda_s);
e = sum(aIt2(:).*layerLabels(:));

% spatial term
% F =  {[1 -1], [1 -1]'};

sigma_i = 7;
Ti2     = 25^2;

for i = 1:length(F)

    
    if size(seg,3) ==1
        % weighte by segmentation difference
        seg_ = conv2(seg, F{i}, 'valid');
        seg_ = 1 - kappa*(seg_==0);
    else
        % weighted by lab color difference
        
        fsz = size(F{i});
        seg_ = zeros(sz(1)-fsz(1)+1, sz(2)-fsz(2)+1);
        for i1 = 1:size(seg,3)
            seg_ = seg_ + conv2(seg(:,:,i1), F{i}, 'valid').^2;
        end;
        
        seg_(seg_>Ti2) = Ti2;
        
        seg_ = exp(-seg_/2/sigma_i^2);
    end;
    
    % back up for gradient computation
    seg__{i} = seg_;
    
    for j = 1:nL-1

        g_ = conv2(g(:,:,j), F{i}, 'valid');
        e   = e + lambda * sum(g_(:).^2.*seg_(:));
        
    end;
end;

% consistency term
e = e + lambda_g*sum((g(:)-warpg2(:)).^2);

% % data term at previous frame
for i = 1:nL
    warps1(:,:,i) = imwarp_grad_im(layer_uv0{i}, layerLabels(:,:,i));
end;
warps1(isnan(warps1)) = 0;

e  = e + sum(aIt20(:).*warps1(:));

% consistency term at previous frame

for i = 1:nL-1       
%     tmp = g(:,:,i);
%     warpg1(:,:,i) = reshape(warp_grad{i}*tmp(:), size(tmp));
    warpg1(:,:,i) = imwarp_grad_im(layer_uv0{i}, g(:,:,i));

end;% or zero?
warpg1(isnan(warpg1)) = g0(isnan(warpg1));  

e  = e + lambda_g*sum((g0(:)-warpg1(:)).^2);
% 
% 

if nargout > 1
    
    % Compute derivative     
    
    % data term
    d = zeros(size(g));

    for j = 1:nL-1
        d(:,:,j) = aIt2(:,:,j).*layerLabels(:,:,j)...
                   .*sigmoid(g(:,:,j),2,lambda_s)./sigmoid(g(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
        
        d(:,:,j) = d(:,:,j) - sum(aIt2(:,:,j+1:nL).*layerLabels(:,:,j+1:nL), 3)...
                                 .*sigmoid(g(:,:,j),2,lambda_s)./sigmoid(-g(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
    end;
    
    % spatial term
    for i = 1:length(F)
        
        seg_ = seg__{i};
            % weighte by segmentation difference
%             seg_ = conv2(seg, F{i}, 'valid');
%             seg_ = 1 - kappa*(seg_==0);
        
        % weighted by lab color difference
%         seg_ = zeros(sz);
%         for i1 = 1:size(seg,3)
%             seg_ = seg_ + conv2(seg(:,:,i1), F{i}, 'valid').^2;
%         end;
%         seg_ = exp(-seg_/2/sigma_i^2);
        
        Fi  = reshape(F{i}(end:-1:1), size(F{i}));
        for j = 1:nL-1       

            g_  = conv2(g(:,:,j), F{i}, 'valid'); 
            
            tmp = conv2(2*g_.*seg_, Fi, 'full');
            
            d(:,:,j)   = d(:,:,j) + lambda * tmp;
        end;
    end;
    
    % consistency term
    d = d + 2*lambda_g*(g-warpg2);


    % data term at previous frame
    
    
    for j = 1:nL
        tmp = aIt20(:,:,j);
        %aIt20w(:,:,j) = reshape(tmp(:)'*warp_grad{j}, size(tmp));         
        aIt20w(:,:,j) = imwarp_adjoint_operator(layer_uv0{j}(:,:,1), layer_uv0{j}(:,:,2), tmp);
    end;
    for j = 1:nL-1
        
        d(:,:,j) = d(:,:,j) + aIt20w(:,:,j).*layerLabels(:,:,j)...
                   .*sigmoid(g(:,:,j),2,lambda_s)./sigmoid(g(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
        
        d(:,:,j) = d(:,:,j) - sum(aIt20w(:,:,j+1:nL).*layerLabels(:,:,j+1:nL), 3)...
                                 .*sigmoid(g(:,:,j),2,lambda_s)./sigmoid(-g(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
    end;    
    
    % consistency term at previous frame
    for i= 1:nL-1
        tmp = 2*lambda_g*(warpg1(:,:,i)-g0(:,:,i));
        %d(:,:,i) = d(:,:,i) + reshape(warp_grad{i}'*tmp(:), size(tmp));
        
        d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uv0{i}(:,:,1), layer_uv0{i}(:,:,2), tmp);
    end;
    
    d = d(:);
end;