function  [uv all uvb allb] = composite_final_output(layerLabels, ...
        layer_uv, layer_uvb, layer_g, T, this)
%%

% if size(this.images,4) > 1
%     for t=1:T
%         colroImages{t} = this.images(:,:,:,t);
%     end;
% else
%     for t=1:T
%         colroImages{t} = repmat(this.images(:,:,t), [1 1 3]);
%     end;
% end;

uv  = cell(1,T-1);
uvb = uv;
for t=1:T-1    
    if this.comb_hard    
    %     uv{t} = composite_final_flow(layer_uv{t}, layerLabels{t});
        uv{t} = composite_final_flow_g(layer_uv{t}, layer_g{t});
        if nargout > 2  
            % backward flow field
            uvb{t} = composite_final_flow_g(layer_uvb{t}, layer_g{t+1});
        end;    
    else
        uv{t} = composite_final_flow_g_soft(layer_uv{t}, layer_g{t}, this.lambda4);        
        if nargout > 2
            % backward flow field
            uvb{t} = composite_final_flow_g_soft(layer_uvb{t}, layer_g{t+1}, this.lambda4);
        end;
    end;
end;

all  = cell(1,T+1);
allb = cell(1,T-1);
for t=1:T-1
    all{t} = composite_illustration_image(uv{t}, this.nLayers, layer_uv{t}, layer_g{t});    
    if nargout > 2
        % backward flow field
        allb{t} = composite_illustration_image(uvb{t}, this.nLayers, layer_uvb{t}, layer_g{t+1});
    end;
end;
%
%all{T} = ini_all; % initial value for the first frame

% mark segmentation inconsistency regions
seg1 = threshold_g(layer_g{1});
seg2 = threshold_g(layer_g{2});
wseg2 = warp_backward(uv{1}, seg2, 'nearest');
all{T+1} = (seg1 == wseg2)*255;    % dark region: occlusion



alpha = 0.7;
for t=1:T
    seg = threshold_g(layer_g{t});
    
    seg = double(seg2color(seg));
    if size(this.images,4) > 1
        cim = this.images(:,:,:,t);
    else
        cim = repmat(this.images(:,:,t), [1 1 3]);
    end;
    
    all{T+1+t}      = (alpha*cim/255+1-alpha).*seg;
    all{2*T+1+t}    = seg;
end;
