function potential_tables = compute_can_flow_spatial_potential_min_sum_bp(can_uv, rho, cliques, lambdaL, type)

% Compute the potential table for flow candidate spatial terms

% tic;
% H = 400;W = 400;
% % H = 100;W = 100;
% can_uv = rand([H W 2 6]);
% rho = robust_function('generalized_charbonnier', 1e-3, 0.45);

% cliques
% vert = im2col((reshape(1:H*W,H,W)),[2 1])';%vertical
% hor  = im2col((reshape(1:H*W,H,W)),[1 2])';%horizontal

H  = size(can_uv,1);
W  = size(can_uv,2);

nV = size(cliques,1);

nC = size(can_uv, 4); 
potential_tables = zeros(H, W, nC*nC);



for c1=1:nC;
    for c2 = 1:nC;
        table = zeros(H,W);
        
        % horitonzal flow field                
        ind1 = [cliques(:,1)] + (c1-1)*2*H*W;
        ind2 = [cliques(:,2)] + (c2-1)*2*H*W;
        dif = can_uv(ind1)-can_uv(ind2);        
        tmp = evaluate(rho, dif);
        
        % vertical flow field       
        ind1 = ind1+H*W;
        ind2 = ind2+H*W;
        dif = can_uv(ind1)-can_uv(ind2);               
        tmp = tmp+evaluate(rho, dif);
        
        if type == 'V'
            table(1:H-1, :) = reshape(tmp, [H-1, W]);            
            potential_tables(:,:, (c1-1)*nC + c2) = table;
        else
            table(:,1:W-1) = reshape(tmp, [H, W-1]);            
            potential_tables(:,:, (c1-1)*nC + c2) = table;
        end;
        
    end;
end;

potential_tables = potential_tables*lambdaL;