function seg = compute_ini_hand_seg(uvf, uvb, seqName)
%%
% Use hand segmentation as initial value

seg = cell(1,length(uvf)+1);

t_sel = round(length(uvf)/2);

fprintf('**********use hand segmentation as initial value for debugging %s\n', seqName);
switch seqName
    case 'Urban2'
        s = load('/u/dqsun/research/program/nips10_flow/data/hand_seg/train_018.mat');
    case 'Urban3'
        s = load('/u/dqsun/research/program/nips10_flow/data/hand_seg/train_019.mat');
    case 'RubberWhale'
        s = load('/u/dqsun/research/program/nips10_flow/data/hand_seg/train_004.mat');
    case 'Urban2Crop'
        s = load('/u/dqsun/research/program/nips10_flow/data/hand_seg/train_018Crop.mat');
end;

seg{t_sel} = s.seg;
sz = size(uvf{t_sel});
sz = sz(1:2);
seg{t_sel} = imresize(seg{t_sel}, sz, 'nearest');
    

for t = t_sel+1:length(uvf)+1
    seg{t} = warp_backward_segmentation(seg{t-1}, uvb{t-1});    
end;

for t = t_sel-1:-1:1
    seg{t} = warp_backward_segmentation(seg{t+1}, uvf{t});    
end;
