function [seg ] = compute_ini_seg(uvf, uvb, nL, nCandidate, rho, init_seg)
%%
% cluster the flow field of first frame into nL groups by affine motion
% then use backward flow to obtain the segmentaion for the following frames

A       = cell(1,nCandidate);
segs    = cell(1,nCandidate);
score   = ones(1,nCandidate)*1e32;
seg     = cell(1,length(uvf)+1);
t_sel   = round(length(uvf)/2);   % selected center frame
nRLSiters = 3;
%keyboard;
if nargin < 5
    %rho = robust_function('quadratic', 1);
    rho = robust_function('generalized_charbonnier', 1e-3, 0.45);
end;

if exist('init_seg', 'var');
    [A score seg{1}] =robust_fit_affine_motion(uvf{1}, nL, rho,...
        nRLSiters, init_seg{1});
else    
    for i = 1:nCandidate
        [A{i} score(i) segs{i}]=robust_fit_affine_motion(uvf{t_sel}, nL, rho);
    end;
    
    [tmp ind] = min(score);
    seg{t_sel} = segs{ind};
end;

%keyboard;
if isempty(seg{length(uvf)})
	for i=2:length(uvf)
		seg{i} = seg{1};
	end
end  



for t = t_sel+1:length(uvf)+1
    seg{t} = warp_backward_segmentation(seg{t-1}, uvb{t-1});    
end;

for t = t_sel-1:-1:1
    seg{t} = warp_backward_segmentation(seg{t+1}, uvf{t});    
end;

