function psi = construct_libDAI_structure_L_affine_dev(indL0, lambdaAff, can_uv, isLogDomain)

%% Penalized the flow field for being away from the affine

% can_uv(:,:,:,1) mean affine flow field
% can_uv(:,:,:,2) composite flow field from previous iteration

H  = size(can_uv,1);
W  = size(can_uv,2);
nC = size(can_uv,4);


potential_tables = zeros(nC, H*W);

tmp = abs(can_uv(:,:,1,1)-can_uv(:,:,1,2)) +...
                        abs(can_uv(:,:,2,1)-can_uv(:,:,2,2));
potential_tables(2,:)    = lambdaAff*tmp(:)';


if isLogDomain
    potential_tables = -potential_tables;
else
    potential_tables = exp(-potential_tables);
end;

psi = cell(1,H*W);

for i=1:H*W;
    psi{i}.Member = indL0+i-1;
    psi{i}.P      = potential_tables(:,i);
end;

