function psi = construct_libDAI_structure_Z1_L_Z2_temporal(aIt2, cliqueT, indZ10, indZ20, indL0, isLogDomain, z1_index, lambdaD, oob, onInd)
%%

% cliqueT first column: Z1 (smaller index), second Z2

% TODO: For valid pixels in z1 that have no corresponding valid pixels in z2
% a pairwise term bewteen it and the corresponding pixels in L
% CURRENT: Pre-set these data terms to be zero so that the compatability
% function is always 0 (1) for that factor

% tic
% isLogDomain = false;
% H = 100; W = 100;
% H = 400;W = 400;
% aIt2 = rand([H W 6]);

% indZ10 = H*W; % first variable is ind*0 in the whole variables
% indZ20 = 0;  
% indL0  = 2*H*W+1;

% can_uv = rand([H W 2 6]);
% cliqueT = round(rand(H*W*3,2)*H*W);
% cliqueT(:,2) = cliqueT(:,2)+H*W;
% cliqueT(cliqueT==0) = 1;

H  = size(aIt2,1);
W  = size(aIt2,2);

nZ = 2;
nL = size(aIt2,3);
nTC = size(cliqueT,1);

% Most of the table states are non-informative
% potential_tables = zeros(nZ, nZ, nL, nTC);
potential_tables = ones(nZ, nZ, nL, nTC)*lambdaD;  % test

% Higher penalty for foreground layer to be occluded by background layer

% z1=z1_index; z2 = z1;
% for l=1:nL
%     ind = cliqueT(:,1) + (l-1)*H*W;    
%     potential_tables(z1, z2, l, :) = aIt2(ind);    
% end;

z1=z1_index; z2 = z1;
% L11 selects the table and two corresponding pixesl are selected 
ind = cliqueT(:,1) + (onInd-1)*H*W;
ind2= z1+(z2-1)*nZ + (onInd-1)*nZ^2 + (0:nTC-1)'*nZ^2*nL;
potential_tables(ind2) = aIt2(ind);

%Change from being observed to occluded/out of boundary
z2  =3-z1_index;
ind2= z1+(z2-1)*nZ + (onInd-1)*nZ^2 + [0:nTC-1]'*nZ^2*nL;
potential_tables(ind2) = lambdaD;    
% potential_tables(z1_index, 3-z1_index, :, :) = lambdaD;    

% convert energy function to log compatability function
% TO DO/TRY: add a scale lambda
if isLogDomain
    potential_tables = -potential_tables;
else
    potential_tables = exp(-potential_tables);
end;

psi = cell(1,nTC);

% cliqueT(:,1) = cliqueT(:,1)-1+indZ10;
% cliqueT(:,2) = cliqueT(:,2)-1+indZ20;

% By default, Z1: 0 to H*W-1; Z2: H*W:2*H*W-1
cliqueT(:,1) = cliqueT(:,1)-1;
cliqueT(:,2) = cliqueT(:,2)-1;

indL = cliqueT(:,1)+indL0;

for i=1:nTC;
    psi{i}.Member = [cliqueT(i,:) indL(i)];
    psi{i}.P      = potential_tables(:,:,:,i);
end;


