function layer_uv = projective2layer(A, sz)
% Convert the projective motion parameters of each layer into dense flow field

[X Y] = meshgrid(1:sz(2), 1:sz(1));
for j = 1:size(A,2)
    u2 = X*A(1,j)+Y*A(2,j)+A(3,j)+X.^2*A(7,j)+X.*Y*A(8,j);
    v2 = X*A(4,j)+Y*A(5,j)+A(6,j)+X.*Y*A(7,j)+Y.^2*A(8,j);
    layer_uv{j} = cat(3, u2, v2);
end;