function [ini_layer_uv_o, ini_layer_uvb_o, seg_o, incon_o, layer_g_o] = ...
convert_to_cont_data(data, solution, params, this)
%%
%%%%%%%%%%% convert to continuous format

T           = size(solution.layer_support, 4);

% upsample flow and segmentation to full size
sz          = size(this.images);
sz          = sz(1:2);
ratio       = params.inputDownRatio;

layer_seg   = support2seg(solution.layer_support);

for t=1:params.T
    seg_o{t} = imresize(layer_seg(:,:,t), sz, 'nearest');
end;

for t=1:params.T-1
    for i=1:params.nLayers
        ini_layer_uv_o{t}{i}  = imresize(...
            data.layer_uv{t}(:,:,:,i), sz)*ratio;
        
        if params.is_symmetric
            ini_layer_uvb_o{t}{i}  = imresize(...
                data.layer_uvb{t}(:,:,:,i), sz)*ratio;
        else
            ini_layer_uvb_o{t}{i}  = ini_layer_uvb{t}{i};
        end;
        
    end;
end;

% mark inconsistent positions in segmentation over time
for t=1:T-1
    uvf = composite_final_flow_seg(ini_layer_uv_o{t},  seg_o{t});    
    tmp = warp_backward_segmentation(seg_o{t+1}, uvf);
    incon_o{t} = repmat(tmp~=seg_o{t}, [1 1 params.nLayers-1]);
    
    % according to backward flow field?
end;

% TODO: check why the program resets all to zero
incon_o{T} = zeros([sz params.nLayers-1]);

% convert discrete layer support to continuous layer support
for t=1:params.T
    tmp          = imresize(solution.layer_support(:,:,:,t), sz, 'nearest');
    layer_g_o{t} = (2*tmp-1)*this.visG;
end;