function [data solution params ] = load_or_refine_disc_init(...
data, solution, params, this, outputDir)
%%
%%%%%%%%%%%%%%% final refinement

if nargin < 5
    outputDir   = [this.extParams.discDir];
end;

fn2 = [outputDir 'stage3_new.mat'];
fn  = [outputDir 'stage3.mat'];

if exist(fn, 'file');
    load(fn, 'data', 'solution');
    s              = load(fn, 'params');
    params.nLayers = s.params.nLayers;
elseif exist(fn2, 'file')
    fn  = fn2;
    load(fn, 'data', 'solution');
    s   = load(fn, 'params');
    params.nLayers = s.params.nLayers;
else        
    [data solution params] = compute_init_gc_all_asym(data,...
        solution, params, this);
    
%     if ~strcmp(params.supMFType, 'no_mf')
%         %%% (weighted) median filtering
%         solution = postprocess_support_functions(solution, data, params);
%     end;
    if this.is_save_mat
        save(fn, 'data', 'solution', 'params');
    end;
    
    en  = evaluate_overall_energy_si_asym(solution, data, params, 1);
    fprintf('energy %3.3e\n', en);
end;

% output_energy_figure(solution, data, params, 'stage3.png');
fn  = [outputDir 'stage3.png'];
img = display_results_si_asym(data, solution);
imwrite(uint8(img), fn);


fprintf('%3.3f min\n', toc/60);