function [data solution params ] = load_or_swap_depth_order_pairiwse_asym(...
data, solution, params, this, outputDir)
%%
%%%%%%%%%%%%%% swap depth ordering

if nargin < 5
    outputDir   = [this.extParams.discDir];
end;

fn = [outputDir 'stage2.mat'];
if exist(fn, 'file');
    load(fn, 'data', 'solution');
    s = load(fn, 'params');
    params.nLayers = s.params.nLayers;    
else    
    [data solution params] = swap_depth_order_pairiwse_asym(data,...
        solution, params);
    if ~strcmp(params.supMFType, 'no_mf')
        % (weighted) median filtering
        solution = postprocess_support_functions(solution, data, params);
    end;
    if this.is_save_mat
        save(fn, 'data', 'solution', 'params');
    end
    
    en  = evaluate_overall_energy_si_asym(solution, data, params, 1);
    fprintf('energy %3.3e\n', en);
end;


fn  = [outputDir 'stage2.png'];
img = display_results_si_asym(data, solution);
imwrite(uint8(img), fn);

% postprocess since depth order already determined
% solution = postprocess_support_functions(solution, data, params);
% params.supMFType = 'wmf';
% if ~strcmp(params.supMFType, 'no_mf')
%     %%% (weighted) median filtering    
% end;
%params.supMFType = 'wmf';
fprintf('%3.3f min\n', toc/60);

