function [data solution ] = swap_depth_order_pairiwse_move_front_asym(data, solution, params)

% data = data2;
% solution = solution2;

layer_seg = support2seg(solution.layer_support);
NN = computeNeighborsPixelNumber(layer_seg(:,:,1));
% nSwap = 50;
pairs = [];
%
for i=1:size(NN,1)
    for j=1:i
        if NN(i,j)> params.nSwapT
            pairs = [pairs; j i];
        end
    end;
end;

%%

for iter =1:params.nSwapIters

    success = true;
    

    %prevEn  = evaluate_overall_energy_si_asym(currSolution, currData, params);
    prevEn  = evaluate_overall_energy_si_asym(solution, data, params);
    fprintf('current lowest energy %3.5e\n', prevEn);        
    for iP=1:size(pairs, 1);
        
        % initialize to previous solutions
        currData = data;
        currSolution = solution;        
       
        % move one layer in front of another        
        [currData currSolution] = move_one_layer_asym(currData,...
            currSolution, params, pairs(iP,:));
        currData    = precompute_asym(currData, params);
        en = evaluate_overall_energy_si_asym(currSolution, currData, params);
        fprintf('energy %3.5e\t', en);
        
        

        currSolution = segment_layers_gc_si_asym(...
            currSolution, params, currData, pairs(iP,1)  );
        en = evaluate_overall_energy_si_asym(currSolution, currData, params);
        fprintf('energy %3.5e\t', en);
        
        % update support function for each layer
        currSolution = segment_layers_change_support_gc_si_asym(...
            currSolution, params, currData, pairs(iP,1) );
        en = evaluate_overall_energy_si_asym(currSolution, currData, params);
        fprintf('energy %3.5e\n', en);        
        currEn = en;
        
        %display_results_si_asym(currData, currSolution);
        
        % when this line was added by chance?
        %prevEn  = evaluate_overall_energy_si_asym(currSolution, currData, params);
        
        
        if currEn < prevEn
            
            % if find lower energy solution, update layer index in pairs
            data     = currData;
            solution = currSolution;
            display_results_si_asym(data, solution); title(sprintf('%3.5e', currEn));
            prevEn = currEn;
            
            tmp_pairs = pairs;
            
            % for moving to front
%            tmp_pairs(pairs == pairs(iP,1)) = pairs(iP,1)+1;
            % only pairwise relationship is fine, always keeps front layer
            % in the first position
            tmp_pairs(pairs == pairs(iP,2)) = pairs(iP,1)+1;
            
            pairs = tmp_pairs;
            
            % make sure the first column is in the front
            pairs = sort(pairs, 2); 
            
            success = 0;
            
        end;
        
        % record swapped pairs
    end;
    
    if success
        break;
    end;
end;

