function [data solution] = swap_layer_pair_asym(data, solution, params, layer_ids)
%%
% swap the depth ordering of two selected layers while retaining the
% visibility mask and making the minimum change to the support functions

nLayers = size(solution.layer_support,3)+1;

layer_ids = sort(layer_ids, 'ascend');

preV   = support2visibility(solution.layer_support);

%swap previous visibility mask
% preV(:,:,layer_ids,:) = preV(:,:,layer_ids(end:-1:1),:);


if max(layer_ids) < nLayers

    sup = solution.layer_support;
    sup(:,:,layer_ids,:) = sup(:,:,layer_ids(end:-1:1),:);    
else
    sup = solution.layer_support;    
    sup(:,:,layer_ids(1),:) = preV(:,:,layer_ids(2),:) == 1;    
end;

% prevSeg = support2seg(solution.layer_support); figure; imagesc(prevSeg(:,:,1));
newV = support2visibility(sup);
% newSeg = support2seg(sup); figure; imagesc(newSeg(:,:,1));

% set visiblity of front layer to be same as before
mask = newV(:,:,layer_ids(1),:) == 1 & preV(:,:,layer_ids(2),:) == 0;
tmp = sup(:,:,layer_ids(1),:);
tmp(mask) = 0;
sup(:,:,layer_ids(1),:) = tmp;

% set visiblity of back layer to be same as before
mask = newV(:,:,layer_ids(2),:) == 0 & preV(:,:,layer_ids(1),:) == 1;
tmp = sup(:,:,1:layer_ids(2)-1,:);
tmp(repmat(mask, [1 1 layer_ids(2)-1 1])) = 0;
sup(:,:,1:layer_ids(2)-1,:) = tmp;

solution.layer_support = sup;

T = size(solution.layer_support,4);

for t=1:T-1;

    data.aff_uv{t}(:,:,:, layer_ids)   =...
        data.aff_uv{t}(:,:,:, layer_ids(end:-1:1));
    data.layer_uv{t}(:,:,:, layer_ids) =...
        data.layer_uv{t}(:,:,:, layer_ids(end:-1:1));
    
    if params.is_symmetric
        data.aff_uvb{t}(:,:,:, layer_ids)   =...
            data.aff_uvb{t}(:,:,:, layer_ids(end:-1:1));
        data.layer_uvb{t}(:,:,:, layer_ids) =...
            data.layer_uvb{t}(:,:,:, layer_ids(end:-1:1));
    end;
    

end;
