function data = estimate_affine_mean(data, flow_sel, layer_support, params)
%%
% layer_seg = support2seg(layer_support);

for t=1:params.T
    
%     uv = composite_flow_from_support(data.can_uv{t}, layer_support(:,:,:,t),...
%             flow_sel{t});
%     
%     data.aff_uv{t} = fit_affine_layer_motion_robust(uv, layer_seg(:,:,t),...
%         params.rho_affine);
    for iL=1:params.nLayers
        uv = composite_final_flow_seg(data.can_uv{t}, flow_sel{t}(:,:,iL));
        data.aff_uv{t}(:,:,:,iL) = fit_affine_robust(uv, params.rho_affine);
    end;
    
%     if params.is_symmetric
%         for iL=1:params.nLayers
%             uv = composite_final_flow_seg(data.can_uvb{t}, flow_sel{t}(:,:,iL));
%             data.aff_uv{t}(:,:,:,iL) = fit_affine_robust(uv, params.rho_affine);
%         end;
%     end;
    
end;
        
function uvo = fit_affine_robust(uv, rho, nRLSiters)
sz = size(uv); 
sz = sz(1:2);

if nargin < 3
    nRLSiters = 10; 
end;


nData = prod(sz);
[X Y] = meshgrid(1:sz(2), 1:sz(1));
x = X(:); y = Y(:);
xy1 = [x y ones(nData, 1)];



u = uv(:,:,1); u = u(:);
v = uv(:,:,2); v = v(:);

A(:,1) = L2_fit(u, xy1);
A(:,2) = L2_fit(v, xy1);

A(:,1) = RLS_fit(u, xy1, rho, nRLSiters, A(:,1));
A(:,2) = RLS_fit(v, xy1, rho, nRLSiters, A(:,2));

% interpolate invisble pixels by affine motion model
u = X*A(1,1)+Y*A(2,1)+A(3,1);
v = X*A(1,2)+Y*A(2,2)+A(3,2);

u = reshape(u, sz);
v = reshape(v, sz);

uvo = cat(3, u,v);


function a = L2_fit(u, xy1)    
% least square fit u = a1x + a2y + a3;
a = (xy1'*xy1)\(xy1'*u);

function s = RLS_fit(u, xy1, rho, niters, s)

for iter = 1:niters;
    err = u - s(1)*xy1(:,1) -s(2)*xy1(:,2)-s(3);
    w = deriv_over_x(rho, err);
    s = (xy1'* [w.*xy1(:,1) w.*xy1(:,2) w] )\(xy1'* (w.*u));
end;
