function vis = support2visibility(support)
%% convert the binary support function to sequential visibility mask
% test code
%

% H = 100; W = 100;
% support = zeros([H W 2]);
% support(1:H/4, 1:W/4, 1) = 1;
% support(1:H/2, 1:W/2, 2) = 1;
% 
% vis = support2visibility( cat(4, support, 1-support) );
% 
% figure; 
% t = 2;
% i=1; subplot(1,3,i); imagesc(vis(:,:,i,t)); 
% i=2; subplot(1,3,i); imagesc(vis(:,:,i,t)); 
% i=3; subplot(1,3,i); imagesc(vis(:,:,i,t)); 

%%

    
% sanity check
if sum(support(:)>1) >0 | sum(support(:)<0) >0
    error('support2seg: binary support should only take values in {0, 1}!');
end;

[H W nLayers T] = size(support);
nLayers = nLayers+1;

vis = zeros(H,W,nLayers,T);

for t=1:T;
    
    % indicator for having been observed or not
    tmp_seg = ones(H,W)*nLayers;
    
    for i=1:nLayers-1
        % visible if support is one and the pixel is unobserved
        vis(:,:,i,t) = (support(:,:,i, t) ==1) & (tmp_seg == nLayers);
        tmp_seg(vis(:,:,i,t)==1) = i;
    end;
    
    vis(:,:,nLayers, t) = tmp_seg == nLayers;    
end;

