function model = load_fc_2_layers_parameters()
%%

model = layer_optical_flow_3D;

model.median_filter_size   = [5 5];
model.texture     = true;
model.pyramid_levels  = 2;
model.pyramid_spacing = 1.25;
model.depth_order     =  'f2s';

model.nGDiters= 2e1;
model.sigma_i = 12;
model.Ti2     = 40^2;
model.lambda3 = 4e0*4^5;
model.lambda7 = 0;
model.Tg      = zeros(1,20);
model.lambda          = 3;
model.lambda_q        = 3;
model.area_hsz        = 7;
model.g_filters   = {[1 -1], [1; -1], [1 0; 0 -1], [0 1; -1 0]};
model.lambda5     = 9;
model.lambda2     = 1e1*4^5;
model.max_iters       = 20;
tmp = logspace(log10(64), log10(64), model.pyramid_levels*model.max_iters);
tmp = reshape(tmp, [model.max_iters model.pyramid_levels])';
model.lambda4s = tmp(end:-1:1, :);

model.depth_order = 'selected';
model.nCandidate      = 25;
model.lambdaAff       = 0;
model.discParams.interpolation_method = 'cubic';
model.discParams.deriv_filter = [1 -8 0 8 -1]/12;
method = 'charbonnier';
sig = 1e-3;
model.discParams.rho_spatial = robust_function(method, sig);
model.discParams.rho_data    = robust_function(method, sig);
model.discParams.rho_affine  = robust_function(method, sig);
model.rho_affine             = robust_function(method, sig);

model.discParams.isMex = true;
model.disDownRatio     = 1;
model.lambdaAffCont    = 0;
model.rho_affine      = robust_function('quadratic', 1);
model.max_iters  = 3;
tmp = logspace(log10(64), log10(64), model.pyramid_levels*model.max_iters);
tmp = reshape(tmp, [model.max_iters model.pyramid_levels])';
model.lambda4s = tmp(end:-1:1, :);
model.discParams.isReuseCommonClustering = true;

model.nLayers         = 2;
model.sigmaNs         = ones(model.nLayers, 1)*1e-3;
model.discSolver      = 'MF';
model.cont_ref        = false;
model.is_use_disc     = false;

model.class_mask = [];
model.isstuff = [];
model.prior = [];

model.fileinfo = [];
model.isstuff = [];
model.prior = [];

model.extParams.lambdaSeg = 89;
model.extParams.lambdaIncon = 3;
model.extParams.lambdaAff = 1e-3;
model.extParams.T2_lab = 1600;

