function [layer_uv, layer_uvb] = estimate_flow_given_layer_mf(mfParams, ...
    images, labImages, layer_q, layer_uv, layer_uvb, model, init_uvs)

data.images    = images;
data.aff_uv    = layer_uv;
data.aff_uvb   = layer_uvb;
data.layer_uv  = layer_uv;
data.layer_uvb = layer_uvb;

if size(labImages,4) > 1
    for t=1:size(labImages,4)
        data.labImages{t}  = labImages(:,:,:,t);
    end
else
    for t=1:size(labImages,3)
        data.labImages{t}  = labImages(:,:,t);
    end
end;
solution.layer_support = layer_q(:,:,:,:,1) >= layer_q(:,:,:,:,2);

gcParams = load_parse_parameters(model);
gcParams.nLayers      = size(layer_uv{1}, 4);
gcParams.is_symmetric = mfParams.useBackFlow;
gcParams.interpolation_method = 'bi-cubic';
gcParams.flowMFType   = 'wmf';
gcParams.cont_refine  = true;
gcParams.lambdaOcc    = mfParams.lambdaOcc;
gcParams.isFlowFusion = mfParams.isFlowFusion;
gcParams.cont_refine_iters = mfParams.cont_refine_iters;

if exist('init_uvs', 'var');
    [data, ~, ~] = refine_flow_move_mf(data, solution,...
        gcParams, model, layer_q, init_uvs);
else
    [data, ~, ~] = refine_flow_move_mf(data, solution,...
        gcParams, model,layer_q);
end;

layer_uv  = data.layer_uv;
layer_uvb = data.layer_uvb;



