function mfObj = evaluate_mean_field_objective_2layers_prealloc(layer_q, mfParams, dataCost,...
    BLMtx, dataCostB, BLMtxB, colorImages, X, Y, oob, oobB)
%%
[H W nL T nValues] = size(layer_q);
nL = nL+1;

mfObj = 0;
% negative entropy
tmp = layer_q.*log(layer_q+eps);
% tmp = layer_q.*log(layer_q);
mfObj = sum(tmp(:));

% fprintf('%3.6e\t', mfObj);
nValues = 2;

%%%%%%% forward flow field
for t=1:T-1    
    for qID = 1:nValues
        %data cost
       
        if mfParams.datatermOn            
            layerID = qID;
            tmp = layer_q(:,:,1,t+1,qID);
            tmp = layer_q(:,:,1,t,qID).*...
                dataCost{t}{layerID}.*...
                reshape(BLMtx{t}{layerID}*tmp(:), size(tmp));
            mfObj = mfObj + sum(tmp(:));
        end;
        
        % temporal Q(g_t =0) * Q(g_t+1 =1) or Q(g_t =1) * Q(g_t+1 =0)
        layerID = 1;
        tmp = layer_q(:,:,1,t+1,nValues+1-qID);
        tmp = layer_q(:,:,1,t,qID).*...
            reshape(BLMtx{t}{layerID}*tmp(:), size(tmp));
        if exist('oob', 'var');
            tmp(oob{t}{layerID}) = 0;
        end;
        mfObj = mfObj + mfParams.lambdaTemp*sum(tmp(:));
    end;
    
end;
% fprintf('%3.6e\t', mfObj);

%%%%%%% backward flow field
if mfParams.useBackFlow
    for t=2:T % current frame to change
        for qID = 1:nValues
            %data cost
            %layerID = 3-qID;
            if mfParams.datatermOn
                layerID = qID;
                tmp = layer_q(:,:,1,t-1,qID);
                tmp = layer_q(:,:,1,t,qID).*...
                    dataCostB{t-1}{layerID}.*...
                    reshape(BLMtxB{t-1}{layerID}*tmp(:), size(tmp));
                mfObj = mfObj + sum(tmp(:));
            end;
            % temporal
            layerID = 1;
            tmp = layer_q(:,:,1,t-1,nValues+1-qID);
            tmp = layer_q(:,:,1,t,qID).*...
                reshape(BLMtxB{t-1}{layerID}*tmp(:), size(tmp));            
            if exist('oobB', 'var');
                tmp(oobB{t-1}{layerID}) = 0;
            end;
            mfObj = mfObj + mfParams.lambdaTemp*sum(tmp(:));
        end;
    end;
end;
% fprintf('%3.6e\t', mfObj);

% spatial term message passing

% The mean field should already be initialized!!

% % Create features for prealloc MF inference
% features_mf = cell(1,T);
% for t=1:T
%     features_mf{t} = cat(3, squeeze(colorImages(:,:,:,t))/mfParams.sigma_i,...
%         X/mfParams.sigma_s, Y/mfParams.sigma_s);
% end
% 
% perform_dense_message_passing_mex_prealloc(2,'a', features_mf, repmat(mfParams.lambdaSpa,1,T));
    
tmp_out = zeros(H,W, nValues);
for t=1:T
    %features = cat(3, squeeze(colorImages(:,:,:,t))/mfParams.sigma_i,...
    %    X/mfParams.sigma_s, Y/mfParams.sigma_s);
    for layerID=1:nL-1
        tmp = squeeze(layer_q(:,:,layerID,t,:));
        %perform_dense_message_passing_mex(....
        %    features, tmp, tmp_out, [mfParams.lambdaSpa]);
        perform_dense_message_passing_mex_prealloc(2,'p',t, tmp,tmp_out);
        
        % two layer case
        if mfParams.spaSubtract
            % message passing needs to subtract its own * weight
            tmp_out = (tmp_out-mfParams.lambdaSpa*tmp).*tmp(:,:,end:-1:1);
        else
            % not easy to subtract the exact value due to weight
            
            % Q(g^p =0) * Q(g^q =1) + Q(g^p =1) * Q(g^q =0)
            tmp_out = tmp_out.*tmp(:,:,end:-1:1);
        end;
        
        
        mfObj = mfObj + sum(tmp_out(:));
    end;
end;

% perform_dense_message_passing_mex_prealloc(2,'d');

% fprintf('%3.6e\t', mfObj);