function mfParams = load_mean_field_parameters(dataset_name)

mfParams.mfOuterIters = 3;
mfParams.mfinnerIters = 60;

mfParams.cont_refine_iters = 1;
mfParams.rhoSpatial = robust_function('generalized_charbonnier', 1e-3, 0.45);
mfParams.rhoData    = robust_function('generalized_charbonnier', 1e-3, 0.45);
mfParams.lambdaOcc  = 8; 

mfParams.lambdaTemp = 1;

mfParams.lambdaTempStart = 1;
mfParams.lambdaTempEnd   = 100;

mfParams.debugFigure  = true;
mfParams.useBackFlow  = true; 
mfParams.datatermOn   = true; % debug only

mfParams.sigma_int    = 100;

% seems a better setting
mfParams.lambdaSpa  = 30;
mfParams.sigma_i  = 8;
mfParams.sigma_s  = 30;

if strcmp(dataset_name, 'kitti') 
    mfParams.lambdaSpaSeg = 100; 
    mfParams.lambdaUnarySseg = 20;
else
    mfParams.lambdaSpaSeg = 1;
    mfParams.lambdaUnarySseg = 6;
end
    
    
mfParams.sigma_spa    = 2;
mfParams.expScale      = 1;
mfParams.expScaleStart = 1; % default no annealing on time
mfParams.expScaleEnd   = 1;
mfParams.spaSubtract  = false;
mfParams.mixStepSize  = 0.6;
mfParams.medflt    = true;
mfParams.mfsize    = [5 5];
mfParams.evalObj     = false;
mfParams.minSpaMsg   = 1e-3;
mfParams.minValueQ  = 1e-300; % minimum value of approximate distribution before normalization
mfParams.bicubicOn  = true;
mfParams.roundFlow  = false;
mfParams.seq_update = true;
mfParams.isFlowFusion  = false;
mfParams.possionInt    = true;
mfParams.possionIntTwice = false;

