function curr_layer_q = pass_message_flow(mfParams, curr_layer_q,...
    layer_q, dataCost, BLMtx, warpedDataCost, T, nValues)
%%
%%%%%%% forward flow field
%   -warping
for t=1:T-1    
    for qID = 1:nValues        
        %data cost       
        neigh_q = layer_q(:,:,1,t+1,qID);        
        if mfParams.datatermOn
            layerID = qID;
            curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID) +...
                dataCost{t}{layerID}.*...
                reshape(BLMtx{t}{layerID}*neigh_q(:), size(neigh_q));
        end;
        
        % temporal
        neigh_q = squeeze(layer_q(:,:,1,t+1,nValues+1-qID));        
        layerID = 1;
        curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID)+...
            mfParams.lambdaTemp*...
            reshape(BLMtx{t}{layerID}*neigh_q(:), size(neigh_q));
    end;
    
end;

%   -transpose of warping
for t=2:T
    for qID = 1:nValues
        %data cost
        neigh_q = squeeze(layer_q(:,:,1,t-1,qID));
        if mfParams.datatermOn
            layerID = qID;      
            
            tmp = neigh_q.*dataCost{t-1}{layerID};
            curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID) +...                
                reshape(BLMtx{t-1}{layerID}'*tmp(:), size(neigh_q));                        
        end;
        
        % temporal
        neigh_q = squeeze(layer_q(:,:,1,t-1,nValues+1-qID));
        layerID = 1;
        curr_layer_q(:,:,1,t,qID) = curr_layer_q(:,:,1,t,qID)+...
            mfParams.lambdaTemp*...
            reshape(BLMtx{t-1}{layerID}'*neigh_q(:), size(neigh_q));
    end;
    
end;