function curr_q = pass_message_flow_one_frame(mfParams, layer_q,...
    dataCost, BLMtx, warpedDataCost, t, T, nValues, curr_q)
%%
%%%%%%% forward flow field
%   -warping

% for two layers only
if t < T 
    for qID = 1:nValues        
        %data cost       
        neigh_q = layer_q(:,:,1,t+1,qID);        
        if mfParams.datatermOn
            layerID = qID;
            curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID) + ...
                dataCost{t}{layerID}.*...
                reshape(BLMtx{t}{layerID}*neigh_q(:), size(neigh_q));
        end;
        
        % temporal
        neigh_q = squeeze(layer_q(:,:,1,t+1,nValues+1-qID));        
        layerID = 1;
        curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID)+ mfParams.lambdaTemp*...
            reshape(BLMtx{t}{layerID}*neigh_q(:), size(neigh_q));
    end;    
end;

%   -transpose of warping
if t > 1
    for qID = 1:nValues
        %data cost
        neigh_q = squeeze(layer_q(:,:,1,t-1,qID));
        if mfParams.datatermOn
            layerID = qID;      
            
            tmp = neigh_q.*dataCost{t-1}{layerID};
            curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID) +...                
                reshape(BLMtx{t-1}{layerID}'*tmp(:), size(neigh_q));                        
        end;
        
        % temporal
        neigh_q = squeeze(layer_q(:,:,1,t-1,nValues+1-qID));
        layerID = 1;
        curr_q(:,:,:,:,qID) = curr_q(:,:,:,:,qID)+...
            mfParams.lambdaTemp*...
            reshape(BLMtx{t-1}{layerID}'*neigh_q(:), size(neigh_q));
    end;
    
end;