function [dataCost warpedDataCost BLMtx oob...
    dataCostB BLMtxB warpedDataCostB oobB] =...
    precompute_mean_field(mfParams, layer_uv, layer_uvb,...
    pyramid_images, T, nL)
%%
%   -compute data matching cost

%keyboard;
for t=1:T-1
    I1 = pyramid_images{1}(:,:,t);
    I2 = pyramid_images{1}(:,:,t+1);
    for layerID = 1:nL
        
        %%%%% forward flow field
        if mfParams.roundFlow
            [BLMtx{t}{layerID} oob{t}{layerID}] = imwarpmtx(...
                round(layer_uv{t}(:,:,1,layerID)),...
                round(layer_uv{t}(:,:,2,layerID)));
        else            
            [BLMtx{t}{layerID} oob{t}{layerID}] = imwarpmtx(...
                layer_uv{t}(:,:,1,layerID), layer_uv{t}(:,:,2,layerID));
        end;
        

        if mfParams.bicubicOn
            It = partial_deriv(cat(3, I1, I2), layer_uv{t}(:,:,:,layerID), 'bi-cubic');
            [Mtx OOB] = imwarpmtx(...
                layer_uv{t}(:,:,1,layerID), layer_uv{t}(:,:,2,layerID));
            dataCost{t}{layerID} = evaluate(mfParams.rhoData, It);
            dataCost{t}{layerID}(OOB) = mfParams.lambdaOcc;
        else
            Iw = reshape(BLMtx{t}{layerID}*I2(:), size(I2));
            It = I1-Iw;
            dataCost{t}{layerID} = evaluate(mfParams.rhoData, It);
            dataCost{t}{layerID}(oob{t}{layerID}) = mfParams.lambdaOcc;
        end;
        
        
        dataCost{t}{layerID} = dataCost{t}{layerID} - mfParams.lambdaOcc; % added
        
        warpedDataCost{t}{layerID} = reshape(BLMtx{t}{layerID}'...
            *dataCost{t}{layerID}(:), size(I2));
        % out of boundary processing?
        
        %%%%% backward flow field
        if mfParams.roundFlow
            [BLMtxB{t}{layerID} oobB{t}{layerID}] = imwarpmtx(...
                round(layer_uvb{t}(:,:,1,layerID)),...
                round(layer_uvb{t}(:,:,2,layerID)));
        else
            [BLMtxB{t}{layerID} oobB{t}{layerID}] = imwarpmtx(...                
                layer_uvb{t}(:,:,1,layerID), layer_uvb{t}(:,:,2,layerID));
        end;
            

        
        
        if mfParams.bicubicOn
            It = partial_deriv(cat(3, I2, I1), layer_uvb{t}(:,:,:,layerID), 'bi-cubic');
            [Mtx OOB] = imwarpmtx(...
                layer_uvb{t}(:,:,1,layerID), layer_uvb{t}(:,:,2,layerID));
            dataCostB{t}{layerID} = evaluate(mfParams.rhoData, It);
            dataCostB{t}{layerID}(OOB) = mfParams.lambdaOcc;
        else        
            Iw = reshape(BLMtxB{t}{layerID}*I1(:), size(I1));
            It = I2-Iw;
            dataCostB{t}{layerID} = evaluate(mfParams.rhoData, It);
            dataCostB{t}{layerID}(oobB{t}{layerID}) = mfParams.lambdaOcc;
        end;
        
        dataCostB{t}{layerID} = dataCostB{t}{layerID} - mfParams.lambdaOcc; % added
        
        warpedDataCostB{t}{layerID} = reshape(BLMtxB{t}{layerID}'...
            *dataCostB{t}{layerID}(:), size(I2));
        
    end;
end;
