function [final_uv, final_seg] = combine_object_flow(num_joint_frames, positions, labels, start_fr, end_fr, objects, layers_supports, init_flow_fwd, segmentations)


gap = num_joint_frames-1;
load('isstuff.mat');
final_uv = cell(1, length(init_flow_fwd));
final_seg = cell(1, length(init_flow_fwd));

for img_idx=start_fr:end_fr-1

	
	init_idx = floor((img_idx-1)/gap) * gap + 1;
    full_uv = init_flow_fwd{img_idx - start_fr + 1}; 
    init_flow = full_uv;
    final_segmentation = zeros(size(full_uv, 1), size(full_uv, 2), 3);
    layer_colors = round(rand(length(positions), 3)*255);

	
	%%% ------------------------------ Add THINGS ------------------------------  

	if ~isempty(labels)
        for layer_idx =1:length(positions)
            if ~isstuff(labels(layer_idx)) 

                % insert bounding boxes in flow field      
                local_uv = objects(layer_idx).flow_fwd{1}; 
                bb = positions{layer_idx}(img_idx-init_idx+1, :);

                % paste in bg 
                support = layers_supports(layer_idx, :);
                mask = repmat((support{mod(img_idx-start_fr, num_joint_frames)+1} > 0), [1, 1, 2]);               		
                full_uv = combine_local_layer_linearly(full_uv, bb, local_uv);

                % paste in planes 
                seg = segmentations(:, :, img_idx-start_fr+1);
                seg = repmat((seg==15) | (seg==18) | (seg==20), [1, 1, 2]);
                full_uv(seg) = init_flow(seg);

                % paste in fg 
                tmp = full_uv(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :);
                tmp(mask) = local_uv(mask);
                full_uv(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :) = tmp;

                % compute final segmentation
                tmp1 = final_segmentation(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :);
                tmp2 = cat(3, mask(:, :, 1)*layer_colors(layer_idx, 1), ...
                mask(:, :, 1)*layer_colors(layer_idx, 2), ...
                mask(:, :, 1)*layer_colors(layer_idx, 3));

                tmp1(logical(repmat(mask(:, :, 1), [1, 1, 3]))) = tmp2(logical(repmat(mask(:, :, 1), [1, 1, 3])));
                final_segmentation(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :) = tmp1;
            end
        end
    end
    
    final_uv{img_idx-init_idx+1} = full_uv; 
    final_seg{img_idx-init_idx+1} = final_segmentation;

end