



function init_flow = estimate_plane_flow(seg1, seg2, uv)


init_flow = uv;
load class_names_segmentation.mat;

% ---------------- fit homography to each blob of road ------------------------

mask1 = name2idx('road', class_names).*uint8(cat(3, seg1 == name2idx('road', class_names), seg2 == name2idx('road', class_names)));
mask2 = name2idx('water', class_names).*uint8(cat(3, seg1 == name2idx('water', class_names), seg2 == name2idx('water', class_names)));
mask3 = name2idx('sky', class_names).*uint8(cat(3, seg1 == name2idx('sky', class_names), seg2 == name2idx('sky', class_names)));
mask = mask1 + mask2 + mask3; 

[positions, labels, ~] = segmentation2bboxes(mask, 21);

if ~isempty(positions{1})
    for box_idx=1:length(positions)
        
        % crop region 
        bb = positions{box_idx}(1, :);        
        local_seg = (mask(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4)) == labels(box_idx));
        local_uv = uv(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :);
          
        % compute homography 
        H_uv = flow2homography(local_uv, local_seg);
            
        if ~isempty(H_uv)
            % paste into initialization 
            tmp = init_flow(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :);
            tmp(repmat(local_seg, [1, 1, 2])) = H_uv(repmat(local_seg, [1, 1, 2]));
            init_flow(bb(1):bb(1)+bb(3), bb(2):bb(2)+bb(4), :) = tmp;
        end
    end
end
        


function H_uv = flow2homography(uv, mask)

u = uv(:, :, 1);
v = uv(:, :, 2);

% compute mask with points that end within frame 
[init_col, init_row] = meshgrid(1:size(uv, 2), 1:size(uv, 1));
end_col = init_col + uv(:, :, 1);
end_row = init_row + uv(:, :, 2);
valid_points = (end_col >= 1) .* (end_col <= size(mask, 2)) .* ...
	(end_row >= 1) .* (end_row <= size(mask, 1));

se = strel('disk',21);
valid_points = imerode(valid_points,se);
se = strel('disk',5);
mask = imerode(mask, se);
mask = logical(mask .* valid_points);

if sum(mask(:)) > 20 
    % compute homography
    [tform, ~, ~] = estimateGeometricTransform(...
        [init_col(mask(:))'; init_row(mask(:))']',...
        [init_col(mask(:))'+u(mask(:))'; init_row(mask(:))'+v(mask(:))']','projective', 'MaxDistance', 1.5);
    % reproject according to homography 
    H_uv = t2flow(tform.T', size(mask));
else
    H_uv = [];
end


