function [e D] = compute_flow_hidden_field_3D_energy(g12, images, colorImages,  layer_uvb_affine, layer_uv_affine, this)

% Data + smoothness prior + temporal consistency term

% for 2 frames symmetric case, solve g g2 together
% $ Date: 2010-7-26$

%%
% clear
% T = 2;
% nL = 4;
% sz = [10 10];
% 
% params.sigma_i = 7;
% params.Ti2     = 20^2;
% params.g_filters   = {[1 -1], [1; -1]};  
% params.spatial_filters  = {[1 -1], [1; -1]};  
% params.kappa = 0.5;
% params.lambda = 1;
% params.lambda2 = 1;
% params.lambda3 = 1;  
% params.lambda4 = 1;
% params.lambda5 = 1;
% params.nLayers = nL;
% params.interpolation_method = 'bi-cubic';  % 'bi-cubic', 'cubic', 'bi-linear'
% params.deriv_filter         = [1 -8 0 8 -1]/12;
% 
% method = 'quadratic'; %'charbonnier'; %'quadratic'; %'geman_mcclure'; %
% a = 1;
% for i = 1:length(params.spatial_filters);
%     params.rho_spatial_u{i}   = robust_function(method, a); % 0.1
%     params.rho_spatial_v{i}   = robust_function(method, a);
% end;
% params.rho_data        = robust_function(method, a); % 6.3
% 
% g  = randn([sz  nL-1 T]);
% uv = randn([sz 2 nL T-1]);
% uvb= randn([sz 2 nL T-1]);
% g12 = [g(:); uv(:); uvb(:)];
% % for t=1:T; colorImages{t} = randn([sz 3]);end;
% for t=1:T; colorImages{t} = randn([sz]); images(:,:,t) = randn([sz]);end;
% for t=1:T-1;
%     for i = 1:nL; layer_uvb{t}{i} = randn([sz 2]); end;
%     for i = 1:nL; layer_uv{t}{i} = randn([sz 2]); end;
%     for i = 1:nL; layer_uvb_affine{t}{i} = randn([sz 2]); end;
%     for i = 1:nL; layer_uv_affine{t}{i} = randn([sz 2]); end;
% end;
% 
% %%
% d = checkgrad('compute_flow_hidden_field_3D_energy', g12, 1e-3, images, colorImages,  layer_uvb_affine, layer_uv_affine, params)


% d = checkgrad('compute_g_con_sim_energy', g12, 1e-3, aIt2{1}, colorImages{1}(:,:,1), colorImages{2}(:,:,1), params.g_filters,...
%                params.kappa, params.lambda2, params.lambda3, params.lambda4, aIt2_b{1}, layer_uvb{1}, layer_uv{1})

%[e d] = compute_g_con_sim_energy(g12, aIt2{1}, colorImages{1}(:,:,1), colorImages{2}(:,:,1), params.g_filters, params.kappa, params.lambda2, params.lambda3, params.lambda4, aIt2_b{1}, layer_uvb{1}, layer_uv{1});

%[e2 d2] = compute_hidden_field_3D_energy(g12, aIt2, colorImages, aIt2_b, layer_uvb, layer_uv, params);
%%
sigma_i = this.sigma_i;
Ti2     = this.Ti2; %20^2;
F       = this.g_filters;
kappa   = this.kappa;
lambda  = this.lambda2;
lambda_g = this.lambda3;
lambda_s = this.lambda4;
lambda_a = this.lambda;

sz = size(layer_uvb_affine{1}{1});
sz = sz(1:2);
nL = length(layer_uvb_affine{1});

T  = length(layer_uvb_affine)+1;

n_g  = prod(sz)*(nL-1);
for t=1:T
    g{t} = reshape(g12((t-1)*n_g+1:t*n_g), [sz nL-1]);        
    s{t} = g2labels(g{t}, lambda_s);
end;

% Arrange flow vectors into matrix
N1 = n_g*T;
n  = prod(sz)*2;
n_uv = n;
N2 = N1+n*(T-1)*nL;
for t=1:T-1
    for l=1:nL
        sta = ((t-1)*nL+l-1)*n+1;
        en  = ((t-1)*nL+l)*n;
        layer_uv{t}{l} = reshape(g12(N1+sta:N1+en), [sz 2]);        
        layer_uvb{t}{l}= reshape(g12(N2+sta:N2+en), [sz 2]);
    end;
end;



% compute data constancy error
for t=1:T-1
    for i=1:this.nLayers;
        
        if nargout > 1       
            
            % Compute BCE for each forward flow field
            [It Ix Iy] = partial_deriv(images(:,:,t:t+1), layer_uv{t}{i}, this.interpolation_method, this.deriv_filter, 1);
            aIt2{t}(:,:,i) = reshape(evaluate(this.rho_data, It(:)), size(It)) - this.lambda5;            
            aIt{t}(:,:,i) = It;
            aIx{t}(:,:,i) = Ix;
            aIy{t}(:,:,i) = Iy;
            
            % Compute BCE for each backward flow field
            [It Ix Iy] = partial_deriv(images(:,:,t+1:-1:t), layer_uvb{t}{i}, this.interpolation_method, this.deriv_filter, 1);
            aIt2_b{t}(:,:,i) = reshape(evaluate(this.rho_data, It(:)), size(It)) - this.lambda5;
            aIt_b{t}(:,:,i) = It;
            aIx_b{t}(:,:,i) = Ix;
            aIy_b{t}(:,:,i) = Iy;
            
        else
            
            % Compute BCE for each forward flow field
            It = partial_deriv(images(:,:,t:t+1), layer_uv{t}{i}, this.interpolation_method, this.deriv_filter);
            aIt2{t}(:,:,i) = reshape(evaluate(this.rho_data, It(:)), size(It)) - this.lambda5;
            
            % Compute BCE for each backward flow field
            It = partial_deriv(images(:,:,t+1:-1:t), layer_uvb{t}{i}, this.interpolation_method, this.deriv_filter);
            aIt2_b{t}(:,:,i) = reshape(evaluate(this.rho_data, It(:)), size(It)) - this.lambda5;
        end;
    end;
end;



% Compute energy

for t=1:T-1
    
    % warp hidden field and layer using FORWARD flow field    
    for i = 1:nL-1
        warpg_f{t}(:,:,i) = imwarp_grad_im(layer_uv{t}{i}, g{t+1}(:,:,i));
    end;
    %warpg_f{t}(isnan(warpg_f{t})) = g{t+1}(isnan(warpg_f{t}));
    warpg_f{t}(isnan(warpg_f{t})) = g{t}(isnan(warpg_f{t}));
    
    % warp toward g{t}, out-of-boundary replicate g{t}
    
    
    for i = 1:nL
        warps_f{t}(:,:,i) = imwarp_grad_im(layer_uv{t}{i}, s{t+1}(:,:,i));        
    end;
    warps_f{t}(isnan(warps_f{t})) = 0;
    
    
    % warp hidden field and layer using BACKWARD flow field
    for i = 1:nL-1
        warpg_b{t}(:,:,i) = imwarp_grad_im(layer_uvb{t}{i}, g{t}(:,:,i));
    end;
    %warpg_b{t}(isnan(warpg_b{t})) = g{t}(isnan(warpg_b{t}));
    warpg_b{t}(isnan(warpg_b{t})) = g{t+1}(isnan(warpg_b{t}));
    
    for i = 1:nL
        warps_b{t}(:,:,i) = imwarp_grad_im(layer_uvb{t}{i}, s{t}(:,:,i));        
    end;
    warps_b{t}(isnan(warps_b{t})) = 0;    
end;

e = 0;
% data term
for t=1:T-1
    % forward flow field
    e = e+ sum(aIt2{t}(:).*s{t}(:).*warps_f{t}(:));
    % backward flow field
    e = e+ sum(aIt2_b{t}(:).*s{t+1}(:).*warps_b{t}(:));
end;

% spatial term for hidden field
seg = colorImages;
for t=1:T
    for i = 1:length(F)
        
        if size(seg{t},3) ==1
            % weighte by segmentation difference
            seg_ = conv2(seg{t}, F{i}, 'valid');
            seg_ = 1 - kappa*(seg_==0);
        else
            % weighted by lab color difference
            fsz = size(F{i});
            seg_ = zeros(sz(1)-fsz(1)+1, sz(2)-fsz(2)+1);
            for i1 = 1:size(seg{t},3)
                seg_ = seg_ + conv2(seg{t}(:,:,i1), F{i}, 'valid').^2;
            end;
            seg_(seg_>Ti2) = Ti2;
            seg_ = exp(-seg_/2/sigma_i^2);
        end;        
        
        if nargout > 1
            % back up for gradient computation
            seg__{t}{i} = seg_;
        end;
        
        for j = 1:nL-1
            g_ = conv2(g{t}(:,:,j), F{i}, 'valid');
            e   = e + lambda * sum(g_(:).^2.*seg_(:));
        end;
    end;
end;

% consistency term
for t=1:T-1
    % forward flow field
    e = e + lambda_g*sum((g{t}(:)-warpg_f{t}(:)).^2);
    % backward flow field
    e = e + lambda_g*sum((g{t+1}(:)-warpg_b{t}(:)).^2);
end;

% spatial term for forward flow field
S = this.spatial_filters;

for t=1:T-1
    for l=1:nL
        for i = 1:length(S)            
            u_ = conv2(layer_uv{t}{l}(:,:,1)-layer_uv_affine{t}{l}(:,:,1), S{i}, 'valid');
            v_ = conv2(layer_uv{t}{l}(:,:,2)-layer_uv_affine{t}{l}(:,:,2), S{i}, 'valid');
                
            e  = e + lambda_a*sum(evaluate(this.rho_spatial_u{i}, u_(:)))...
                   + lambda_a*sum(evaluate(this.rho_spatial_v{i}, v_(:)));                
        end;       
    end;
end;

% spatial term for backward flow field
S = this.spatial_filters;

for t=1:T-1
    for l=1:nL
        for i = 1:length(S)            
            u_ = conv2(layer_uvb{t}{l}(:,:,1)-layer_uvb_affine{t}{l}(:,:,1), S{i}, 'valid');
            v_ = conv2(layer_uvb{t}{l}(:,:,2)-layer_uvb_affine{t}{l}(:,:,2), S{i}, 'valid');
                
            e  = e + lambda_a*sum(evaluate(this.rho_spatial_u{i}, u_(:)))...
                   + lambda_a*sum(evaluate(this.rho_spatial_v{i}, v_(:)));                
        end;       
    end;
end;



if nargout > 1
    
    % Compute derivative     
    
    %%%%% derivative w.r.t. g    
    
    % spatial term
    for t=1:T         
        d = zeros(size(g{t}));                
        for i = 1:length(F)
            seg_ = seg__{t}{i};
            Fi  = reshape(F{i}(end:-1:1), size(F{i}));
            for j = 1:nL-1
                g_  = conv2(g{t}(:,:,j), F{i}, 'valid');
                tmp = conv2(2*g_.*seg_, Fi, 'full');
                d(:,:,j)   = d(:,:,j) + lambda * tmp;
            end;
        end;
        all_d{t} = d;
    end;

    % forward flow field
    for t=1:T-1
        d = zeros(size(g{t})); 
        % data term at current frame
        for j = 1:nL-1
            d(:,:,j) = aIt2{t}(:,:,j).*warps_f{t}(:,:,j).*s{t}(:,:,j)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
            
            d(:,:,j) = d(:,:,j) - sum(aIt2{t}(:,:,j+1:nL).*warps_f{t}(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;
        % consistency term at current frame
        d = d + 2*lambda_g*(g{t}-warpg_f{t});
        
        all_d{t} = all_d{t}+d;
    end;
        
    for t=2:T
        d = zeros(size(g{t}));
        
        % data term at previous frame
        for j = 1:nL
            tmp = aIt2{t-1}(:,:,j).*s{t-1}(:,:,j);
            aIt2_bw(:,:,j) = imwarp_adjoint_operator(layer_uv{t-1}{j}(:,:,1), layer_uv{t-1}{j}(:,:,2), tmp);
        end;        
        for j = 1:nL-1
            d(:,:,j) = aIt2_bw(:,:,j).*s{t}(:,:,j)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
            
            d(:,:,j) = d(:,:,j) - sum(aIt2_bw(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;        
        
        %consistency term at previous frame        
        for i= 1:nL-1
            tmp = 2*lambda_g*(warpg_f{t-1}(:,:,i)-g{t-1}(:,:,i));
            d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uv{t-1}{i}(:,:,1), layer_uv{t-1}{i}(:,:,2), tmp);
        end;
        
        all_d{t} = all_d{t}+d;        
    end;
    
    % backward flow field
    for t=2:T
        d = zeros(size(g{t}));        
        
        % data term at current frame
        for j = 1:nL-1
            d(:,:,j) = aIt2_b{t-1}(:,:,j).*warps_b{t-1}(:,:,j).*s{t}(:,:,j)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)            
            d(:,:,j) = d(:,:,j) - sum(aIt2_b{t-1}(:,:,j+1:nL).*warps_b{t-1}(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;
        
        % consistency term at current frame
        d = d + 2*lambda_g*(g{t}-warpg_b{t-1});
       
        all_d{t} = all_d{t}+d;
    end;
    
    for t=1:T-1
        
        d = zeros(size(g{t}));
        % data term at next frame
        for j = 1:nL
            tmp = aIt2_b{t}(:,:,j).*s{t+1}(:,:,j);
            aIt2_bw(:,:,j) = imwarp_adjoint_operator(layer_uvb{t}{j}(:,:,1), layer_uvb{t}{j}(:,:,2), tmp);
        end;
        
        for j = 1:nL-1            
            d(:,:,j) = d(:,:,j) + aIt2_bw(:,:,j).*s{t}(:,:,j)... 
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(g{t}(:,:,j),1,lambda_s); % = lambda_4 sigmoid(-g(:,:,j),1)
            
            d(:,:,j) = d(:,:,j) - sum(aIt2_bw(:,:,j+1:nL).*s{t}(:,:,j+1:nL), 3)...
                .*sigmoid(g{t}(:,:,j),2,lambda_s)./sigmoid(-g{t}(:,:,j),1,lambda_s);  % = lambda_4 sigmoid(g(:,:,j),1)
        end;

   
        % consistency term at next frame
        for i= 1:nL-1
            tmp = 2*lambda_g*(warpg_b{t}(:,:,i)-g{t+1}(:,:,i));
            d(:,:,i) = d(:,:,i) + imwarp_adjoint_operator(layer_uvb{t}{i}(:,:,1), layer_uvb{t}{i}(:,:,2), tmp);
        end;       
 
        all_d{t} = all_d{t}+d;

    end;

    d12 = zeros(1, n_g*T);
    d12 = d12(:);    
    for t=1:T
        d12((t-1)*n_g+1:t*n_g) = all_d{t}(:);
    end;
    
    %%%% Forward flow field
    S   = this.spatial_filters;
    Duv = zeros(1, n_uv*nL*(T-1));   

    for t=1:T-1
        for l=1:nL
            %duv = zeros(size(layer_uv_affine{1}{1}));
            
            % data term - data constancy part
            temp   = reshape(deriv(this.rho_data, aIt{t}(:,:,l)), size(aIt{t}(:,:,l)));                        
            temp   = temp.*s{t}(:,:,l).*warps_f{t}(:,:,l);
            duv(:,:,1) = temp.*aIx{t}(:,:,l);
            duv(:,:,2) = temp.*aIy{t}(:,:,l);
            
            % data term - warped soft segmentation part (approximation)            
             tempx = imfilter(warps_f{t}(:,:,l), this.deriv_filter,  'corr', 'symmetric', 'same');
             duv(:,:,1) = duv(:,:,1)+ aIt2{t}(:,:,l).*s{t}(:,:,l).*tempx;

             tempy = imfilter(warps_f{t}(:,:,l), this.deriv_filter',  'corr', 'symmetric', 'same');
             duv(:,:,2) = duv(:,:,2)+ aIt2{t}(:,:,l).*s{t}(:,:,l).*tempy; 

            % temporal consistency term for nL-1 hidden fields
            if l<nL
                tempx = imfilter(warpg_f{t}(:,:,l), this.deriv_filter,  'corr', 'symmetric', 'same');                
                duv(:,:,1) = duv(:,:,1) + 2*lambda_g*(warpg_f{t}(:,:,l) - g{t}(:,:,l)).*tempx;
                
                tempy = imfilter(warpg_f{t}(:,:,l), this.deriv_filter',  'corr', 'symmetric', 'same');
                duv(:,:,2) = duv(:,:,2) + 2*lambda_g*(warpg_f{t}(:,:,l) - g{t}(:,:,l)).*tempy;
            end;
            
            % spatial term
            for i = 1:length(S)
                
                u_ = conv2(layer_uv{t}{l}(:,:,1)-layer_uv_affine{t}{l}(:,:,1), S{i}, 'valid');
                v_ = conv2(layer_uv{t}{l}(:,:,2)-layer_uv_affine{t}{l}(:,:,2), S{i}, 'valid');
                
                Si = reshape(S{i}(end:-1:1), size(S{i}));                
                
                u_ = reshape(deriv(this.rho_spatial_u{i}, u_(:)), size(u_));
                v_ = reshape(deriv(this.rho_spatial_v{i}, v_(:)), size(v_));
                
                duv(:,:,1) = duv(:,:,1)+lambda_a*conv2(u_, Si, 'full');
                duv(:,:,2) = duv(:,:,2)+lambda_a*conv2(v_, Si, 'full');
            end;
            
            
            sta = ((t-1)*nL+l-1)*n_uv+1;
            en  = ((t-1)*nL+l)*n_uv;
            Duv(sta:en) = duv(:);
        end;
    end;
    
    %%%% Backward flow field    
    Duvb = zeros(1, n_uv*nL*(T-1));   

    for t=1:T-1
        for l=1:nL
            %duv = zeros(size(layer_uv_affine{1}{1}));
            
            % data term
            temp   = reshape(deriv(this.rho_data, aIt_b{t}(:,:,l)), size(aIt_b{t}(:,:,l)));            
            temp   = temp.*s{t+1}(:,:,l).*warps_b{t}(:,:,l);
            
            duv(:,:,1) = temp.*aIx_b{t}(:,:,l);
            duv(:,:,2) = temp.*aIy_b{t}(:,:,l);

            % data term - warped soft segmentation part (approximation)            
%              duv(:,:,1) = duv(:,:,1)+ aIt2_b{t}(:,:,l).*s{t+1}(:,:,l)...
%                           .*imfilter(warps_b{t}(:,:,l), this.deriv_filter,  'corr', 'symmetric', 'same');
% 
%              duv(:,:,2) = duv(:,:,2)+ aIt2_b{t}(:,:,l).*s{t+1}(:,:,l)...
%                            .*imfilter(warps_b{t}(:,:,l), this.deriv_filter',  'corr', 'symmetric', 'same'); 
            
            % data term - warped soft segmentation part (approximation)            
            tempx = imfilter(warps_b{t}(:,:,l), this.deriv_filter,  'corr', 'symmetric', 'same');
            duv(:,:,1) = duv(:,:,1)+ aIt2_b{t}(:,:,l).*s{t+1}(:,:,l).*tempx;

            tempy = imfilter(warps_b{t}(:,:,l), this.deriv_filter',  'corr', 'symmetric', 'same');
            duv(:,:,2) = duv(:,:,2)+ aIt2_b{t}(:,:,l).*s{t+1}(:,:,l).*tempy; 

            % temporal consistency term for nL-1 hidden fields
            if l<nL               
                
                tempx = imfilter(warpg_b{t}(:,:,l), this.deriv_filter,  'corr', 'symmetric', 'same');                
                duv(:,:,1) = duv(:,:,1) + 2*lambda_g*(warpg_b{t}(:,:,l) - g{t+1}(:,:,l)).*tempx;
                
                tempy = imfilter(warpg_b{t}(:,:,l), this.deriv_filter',  'corr', 'symmetric', 'same');
                duv(:,:,2) = duv(:,:,2) + 2*lambda_g*(warpg_b{t}(:,:,l) - g{t+1}(:,:,l)).*tempy;
            end;
            
            
            % spatial term
            for i = 1:length(S)
                
                u_ = conv2(layer_uvb{t}{l}(:,:,1)-layer_uvb_affine{t}{l}(:,:,1), S{i}, 'valid');
                v_ = conv2(layer_uvb{t}{l}(:,:,2)-layer_uvb_affine{t}{l}(:,:,2), S{i}, 'valid');
                
                Si = reshape(S{i}(end:-1:1), size(S{i}));                
                
                u_ = reshape(deriv(this.rho_spatial_u{i}, u_(:)), size(u_));
                v_ = reshape(deriv(this.rho_spatial_v{i}, v_(:)), size(v_));
                
                duv(:,:,1) = duv(:,:,1)+lambda_a*conv2(u_, Si, 'full');
                duv(:,:,2) = duv(:,:,2)+lambda_a*conv2(v_, Si, 'full');
            end;
            
            % temporal consistency term
            
            sta = ((t-1)*nL+l-1)*n_uv+1;
            en  = ((t-1)*nL+l)*n_uv;
            Duvb(sta:en) = duv(:);
        end;
    end;
    
    D = [d12(:); Duv(:); Duvb(:)];
end;