function [neighbors OOB]= compute_temporal_neigbhors(uv)
%%
% compute tepmoral neighbors according to flow field and the mask of pixels
% that move out of image boundaries

H = size(uv,1);
W = size(uv,2);

[X Y] = meshgrid(1:W, 1:H);

x = X + uv(:,:,1);
y = Y + uv(:,:,2);

OOB = (x>W) | (x<1) | (y>H) | (y<1);

x(OOB) = X(OOB);
y(OOB) = Y(OOB);

% round to nearest pixels
% may include the four nearest pixels in future
x = round(x);
y = round(y);

neighbors = sub2ind([H W], y, x);